;#define GEN2K_GHIJ
#ifdef GEN2K_GHIJ

GEN_ADDR = 0				; variant B2
;GEN_ADDR =2000				; variant C2
;GEN_ADDR =4000				; variant D2
;GEN_ADDR =6000				; variant E2

VarNam = GEN_ADDR/2000+$27		;

#else

GEN_ADDR = 0				; variant A2
VarNam = $26				;

#endif
	.org $4009			; 16393
		
; System variables.

VERSN	.db 0
E_PPC	.dw 2
D_FILE	.dw Display
DF_CC	.dw Display+1			; First character of display
VARS	.dw Variables
DEST	.dw 0
E_LINE	.dw BasicEnd 
CH_ADD	.dw BasicEnd			;
X_PTR	.dw 0
STKBOT	.dw BasicEnd+5
STKEND	.dw BasicEnd+5			; Empty stack
BREG	.db 0
MEM	.dw MEMBOT
UNUSED1	.db 0
DF_SZ	.db 2
S_TOP	.dw $0002			; Top program line number
LAST_K	.dw $FDBF
DEBOUN	.db 15
MARGIN	.db 55
NXTLIN	.dw 0 				; Next line address
OLDPPC	.dw 0
FLAGX	.db 0
STRLEN	.dw 0
T_ADDR	.dw $0C8D
SEED	.dw 0
FRAMES	.dw $F5A3
COORDS	.dw 0
PR_CC	.db $BC
S_POSN	.dw $1821
CDFLAG	.db $40
PRBUFF	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,$76 ; 32 Spaces + Newline
MEMBOT	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 30 zeros
UNUSED2	.dw 0

; End of system variables

Program	
Line0
	.db $00,$00			; Line 0
	.dw Line0End-Line0Text		; Line 0 length
Line0Text
	.db $EA				; REM		
	
;	=========================================================== 16514

	jr zxcalc

;	=========================================================== 16516

	jr newcalc

;	=========================================================== 16518
gen2Knum
	ld hl,(VARS)		;
	ld de,6			;
	add hl,de		; Variables+6 => array(1)
	push hl			; save pointer
	ex de,hl		; the destination is the array
	ld hl,GEN_ADDR		; the 1st address in the ROM
	ld bc,8000		; the byte counter

	ld a,$A1		; the 1st byte
	ld (next_num+1),a	; save as exponent base
next_num
	ld a,$A1		; the 1st byte

#ifdef GEN2K_GHIJ

	push hl			;
#endif
	xor $21			;
	ld (next_num+1),a	;

	ld (de),a		; save as exponent
	inc de			; set dest. pointer
	ldi			; copy the MSB of the mantissa
	ldi			; ..
	ldi			; ..
	ldi			; copy the LSB of the mantissa

#ifdef GEN2K_GHIJ

	pop hl			;
	inc hl			;
#endif
	jp pe,next_num		; BC=0?, back if not

	pop bc			; BC points element 1 of array A
	ret			;
;
;	=================================================================
newcalc
	ld hl,addition		;
	jr saveaddr		;
zxcalc
	ld hl,$1755		; ROM entry of the addition
saveaddr
	ld (entry_pt+1),hl	; put the call address

;	--------------------------------------------------------

	call gen2Knum		; fill array (2000 numbers)

	ld d,b			; DE = array(1) addr. 
	ld e,c			;
	ld bc,1000		; op. counter
	ld hl,5			;
	add hl,de		; HL = array(2) addr.

	ex de,hl		; 
	push hl			; save array(1) addr.
	
;	--------------------------------------------------------
setFRM
	ld hl,FRAMES		; point to frame counter
	ld a,(hl)		; fetch the LSB
tstFRM
	cp (hl)			; next frame?
	jr z,tstFRM		; no, test again

	xor a			; clear A
	ld (hl),a		; and the LSB
	inc hl			; then
	ld (hl),a		; MSB of the counter

;	--------------------------------------------------------

	pop hl			; array(1) addr.
	push de			; save array(2) addr.
testloop
	push bc			; save counter
	push hl			; save OP1 addr.
	push de			; save OP2 addr.
entry_pt
	call $0000		; the basic operation

	pop hl			; OP2 addr.
	ld bc,10		;
	add hl,bc		;
	ex de,hl		; next OP2

	pop hl			; OP1 addr.
	add hl,bc		; next OP1

	pop bc			; restore counter
	dec bc			;
	ld a,b			;
	or c			;
	jr nz,testloop		;

;	--------------------------------------------------------
getFRM
	ld hl,(FRAMES)		; read the frame counter

	ex (sp),hl		; save FRAMES value and
	ld d,h			; set pointers to
	ld e,l			; array(2) element

;	--------------------------------------------------------

	ld bc,1000		; 999 numbers to move
	jr count		;
move_res
	ldir			; move a number
	pop bc			; restore counter
count
	dec bc			;
	ld a,b			;
	or c			;
	jr z,exit		;

	push bc			; save counter
	ld bc,5			;
	add hl,bc		;
	jr move_res		;

;	--------------------------------------------------------
exit
	pop bc			; restore FRAMES value
	ld a,b			; then make it positive
	cpl			;
	ld b,a			;
	ld a,c			;
	cpl			;
	ld c,a			;
	inc bc			; and return with value in BC
	ret			;
;
; ==============================================================
; =======		ARITHMETIC ROUTINES		 =======
; ==============================================================
;
;	hl: points the LSB of the greater number's mantissa
;	a:  the LSB of the greater number's mantissa
;	b'7: the rounding bit
;	B(MSB),C,D,E(LSB) contain the less number's mantissa
sub_OP2
	exx			; ..	(alternate set)
	rl b			; the rounding bit (B'7)
	exx			;  ..	(main set)

	sbc a,e			; the real subtraction
	ld e,a			; 4th byte of the mantissa
	dec hl			;
	ld a,(hl)		;
	sbc a,d			;
	ld d,a			; 3rd byte of the mantissa
	dec hl			;
	ld a,(hl)		;
	sbc a,c			;
	ld c,a			; 2nd byte of the mantissa
	dec hl			;
	ld a,(hl)		;
	set 7,a			; the msb is always '1'
	sbc a,b			;
	ld b,a			; B(MSB),C,D,E(LSB): the result's mantissa

	ld h,b			;
	ld l,c			; HL: the upper word of the result's mantissa
	jr nc,sub_spos		; skip if it is positive

	ld hl,1			; else negate the mantissa
	sbc hl,de		;
	ex de,hl		;
	add hl,de		; clear HL
	sbc hl,bc		; H,L,D,E: the result's mantissa
sub_spos
	ld bc,$1f00		; set counters
	ld a,c			; clear A
	rra			; A7 indicates the sign change
sub_norm
	bit 7,h			; normalize
	jr nz,sub_end		; done if msb=1

	ex de,hl		;
	add hl,hl		; double the lower word of the result's mantissa
	ex de,hl		;
	adc hl,hl		; double the upper word of the result's mantissa
	inc c			; set counter
	djnz sub_norm		; max. 31 shifts are accepted
;
;	--------------------------------------------------------
;
	pop hl			; drop return address 
	pop hl			; drop the greater exponent 
	jr z_result		; the result is zero
;
;	--------------------------------------------------------
sub_end
	xor h			; set the sign bit
	ld b,a			; store the MSB of the mantissa
	ld a,c			; store the counter
	ld c,l			; the 2nd byte of the mantissa
	ret	
;
;	========================================================
;
; ---------------------------
; THE 'SUBTRACTION' OPERATION
; ---------------------------
; just switch the sign of subtrahend and do an add.
;
;; subtract (L174C)
;
;	========================================================
; in:
;	hl: points OP1 (the destination)
;	de: points OP2
;
subtract
	LD A,(DE)		; fetch exponent byte of second number the
				; subtrahend. 
	AND A			; test for zero
	RET Z			; return if zero - first number is result.

	INC DE			; address the first mantissa byte.
	LD A,(DE)		; fetch to accumulator.
	XOR $80			; toggle the sign bit.
	LD (DE),A		; place back on calculator stack.
	DEC DE			; point to exponent byte.
				; continue into addition routine.
;
;	========================================================
;
; ----------------------------
; THE new 'ADDITION' OPERATION
; ----------------------------
;
;; addition (L1755)
;
;	========================================================
; in &
; out:	hl: points OP1 (the destination)
;	de: points OP2
;
addition
	ld a,(de)		; fetch OP2.exp 
	and a			; =0?
	ret z			; if yes, then OP1 is the result

	ld c,a			; save OP2.exp
	ld a,(hl)		; fetch OP1.exp
	and a			; =0?

	push de			; save the original
	push hl			; pointers

	jr z,fw_OPcpy		; if OP1=0, then OP2 is the result
				; return via 'copy_OP2'
	ld b,a			; save OP1.exp
	sub c			; OP1.exp-OP2.exp

	cp 33			; test distance
	jr c,pos_dist		; jump if it is less than 33 bit

	cp -32			; if it is more
	jp c,diff_33p		; then return

	cpl			; the difference is negative
	inc a			; so negate it
	ld b,c			; change the greater exponent
	ex de,hl		; de points the less number
pos_dist
	push bc			; save the greater exponent (B)
	inc hl			; n1
	ld c,(hl)		; sgn
	push hl			; save pointer (man. of the greater num.)
	ex de,hl		; hl points the less exponent

	inc hl			; m1
	ld b,(hl)		; sgn
	push bc			; save MSBs
	
	inc hl			; m2
	ld c,(hl)		;
	inc hl			; m3
	ld d,(hl)		;
	inc hl			; m4
	ld e,(hl)		; the LSB

	set 7,b			; the msb is always '1'

	and a			; test distance (& clear CY)
	jr z,skp_shft		; skip shifting if zero
add_shft
	srl b			; 0 -> bbbbbbbb -> CY
	rr c			; CY -> cccccccc -> CY
	rr d			; CY -> dddddddd -> CY
	rr e			; CY -> eeeeeeee -> CY
	dec a			;
	jr nz,add_shft		;
skp_shft
	exx			; ..	(alternate set)
	rr b			; save rounding bit (B'7)
	exx			; ..	(main set)

	pop hl			; the MSBs contain the sign bits
	ld a,h			; which select the next operation:
	xor l			; if A7=0 then addition else subtraction

	ld h,l			; save sign bit (H7) and HL now
	ex (sp),hl		; points the greater number's MSB

	rla			; if CY=0 then addition else subtraction
	call addorsub		; execute operation

	pop hl			; the sign bit (h7)
	ex (sp),hl		; H = the greater exponent

	and a			; test correction's value
	jp m,add_nexp		; jump if it is negative
sub_pexp
	ld l,a			; else decrease
	ld a,h			; the exponent
	sub l			; w. correction
	jr z,z_result		; skip if underflow (<=0)

	jr nc,set_Exp1		; else store the return value
;
;	--------------------------------------------------------
z_result
	pop hl			; drop flags 
	pop hl			; restore the OP1 pointer
	xor a			;
	ld (hl),a		; clear OP1.exp

	ld c,a			; clear the
	ld d,a			; arithmetic
	ld e,a			; buffer
	jr OP1_fill		; and set OP1 as zero
;
;	--------------------------------------------------------
set_Exp1
	pop hl			; the sign bit (H7)
	ex (sp),hl		; points OP1
	ld (hl),a		; set OP1.exp

	ld a,$80		; mask of the sign bit (A7)
	xor b			; toggle
	ld b,a			; the sign bit (B7)

	pop af			; the new sign bit (A7)
	and $80			; mask out the sign bit
	xor b			; apply changes
OP1_fill
	push hl			;
	inc hl			; points OP1.man1
	ld (hl),a		;
	inc hl			; points OP1.man2
	ld (hl),c		;
	inc hl			; points OP1.man3
	ld (hl),d		;
	inc hl			; points OP1.man4
	ld (hl),e		;
ret_OP1
	pop hl			; restore the 
	pop de			; pointers
	ret			; done
;
;	========================================================
;
; ---------------------------------------
; THE improved 'MULTIPLICATION' OPERATION
; ---------------------------------------
;
;; multiply (L17C6)
;
;	========================================================
; in &
; out:	hl: points OP1 (the destination)
;	de: points OP2
;
multiply
	ld a,(hl)		; fetch OP1.exp
	and a			; if it is zero,
	ret z			; then the result is zero

	ld b,a			; store exp1
	ld a,(de)		; fetch OP2.exp
	and a			; test zero

	push de			; save the original
	push hl			; pointers
fw_OPcpy
	jr z,copy_OP2		; OP2=0? -> return via 'copy_OP2'
	
	ld c,a			; store exp2
	push bc			; save exp1,exp2

	call fetchOps		; fetch both mantissas into Z80 registers

	push af			; man1.S * man2.S
	push hl			; save pointer to the next calculator literal
	sbc hl,hl		; H'L'H,L = 0

	ld a,b			; transfer high mantissa byte of first number
	ld b,$20		; register B can now be used to count 32 shifts.
; ---
;
mul_loop
	rra			; C > 76543210 > C
	rr c			; C > 76543210 > C
	exx			; ..	(main set)
	rr b			; C > 76543210 > C
	rr c			; C > 76543210 > C

	jr nc,skip_add		; skip if no carry, else add in the multiplicand.

	add hl,de		; add the lower word to result
	exx			; switch to more significant bytes.
	adc hl,de		; add high bytes of multiplicand and any carry.
	exx			; switch back to main set
skip_add
	exx			; ..	(alternate set)
	rr h			; C > 76543210 > C
	rr l			; C > 76543210 > C
	exx			; ..	(main set)
	rr h			; C > 76543210 > C
	rr l			; C > 76543210 > C
	exx			; ..	(alternate set)

	djnz mul_loop		; loop back 32 times

	ex (sp),hl		; save upper word of the mantissa and
				; restore pointer to the next calculator literal
	exx			; switch back to main set 
	ex de,hl		; 
	pop bc			; mantissa in B(MSB),C,D,E(LSB)

	pop hl			; man1.S * man2.S
	ex (sp),hl		; exp1,exp2

	bit 7,b			; if the mantissa's msb is '1',
	jr nz,man_isOK		; then skip the shifting

	rl e			; else shift left the mantissa
	rl d			; 
	rl c			; 
	rl b			;
	rla			; underflow bit to CY
	dec h			; exponent correction
man_isOK
	ld a,0			; set correction to zero
	call c,round32b		; round if it is necessary

	add a,l			; fetch exp2 with correction
	sub $80			; remove the offset
	jp p,add_pexp		; jump if it is not negative
sub_nexp
	neg			; else make it positive,
	jr sub_pexp		; then go to subtract from exp1
;
;	========================================================
;
; 	addition joins here if difference between exponents is more than 32
;	the final result will be the number with greater exponent
;
diff_33p
	rla			; if difference is positive,
	jr nc,ret_OP1		; then OP1 is the result, else
copy_OP2
	ex de,hl		; exchange the pointers
	ld bc,5			; 5 bytes to copy
	ldir			; copy
	jr ret_OP1		; restore the pointers
;
;	========================================================
;
; -----------------------------------------------
; successor of THE 'FETCH TWO NUMBERS' SUBROUTINE
; -----------------------------------------------
; This routine is used by multiplication and division to fetch the two
; five-byte numbers' mantissa addressed by HL and DE from the calculator
; stack into the Z80 registers.
;
; In: HL points OP1, DE points OP2
;
; Out:	B'C'B,C	: OP1.man
;	D'E'D,E	: OP2.man
;	HL = 0
;	A7 = sign bit of the (later) result
;
fetchOps
	inc de			; set OP2 pointer
	ld a,(de)		; fetch MSB of the man2
	inc hl			; set OP1 pointer
	ld b,(hl)		; fetch MSB of the man1
	xor b			; A7 = man1.S * man2.S (and CY=0!)

	inc hl			; set OP1 pointer
	ld c,(hl)		; fetch man1.2
	push bc			; save man1.1,man1.2

	inc hl			; set OP1 pointer
	ld b,(hl)		; fetch man1.3
	inc hl			; fetch set OP1 pointer
	ld c,(hl)		; fetch man1.4

	ex de,hl		; HL points now OP2

	ld d,(hl)		; fetch man2.1
	inc hl			; set OP2 pointer
	ld e,(hl)		; fetch man2.2
	push de			; save man2.1,man2.2

	inc hl			; set OP2 pointer
	ld d,(hl)		; fetch man2.3
	inc hl			; set OP2 pointer
	ld e,(hl)		; fetch man2.4

	sbc hl,hl		; clear HL
	
	exx			; switch to alternate set
	pop de			; man2.1,man2.2 
	set 7,d			; the msb is always '1'
	pop bc			; man1.1,man1.2 
	set 7,b			; the msb is always '1'

	ret			;
;
;	========================================================
;
;	CY indicates the operation: 0=addition 1=subtraction
;	hl: points the MSB of the greater number's mantissa
;	b'7: the rounding bit
;	B(MSB),C,D,E(LSB) contain the less number's mantissa
addorsub
	inc hl			; set pointer
	inc hl			;
	inc hl			; HL now points the LSB of the mantissa
	ld a,(hl)		; fetch the LSB of the mantissa

	jp c,sub_OP2		; CY=1? --> subtraction

	add a,e			; the real addition
	ld e,a			; 4th byte of the mantissa
	dec hl			;
	ld a,(hl)		;
	adc a,d			;
	ld d,a			; 3rd byte of the mantissa
	dec hl			;
	ld a,(hl)		;
	adc a,c			;
	ld c,a			; 2nd byte of the mantissa
	dec hl			;
	ld a,(hl)		;
	set 7,a			; the msb is always '1'
	adc a,b			;
;
;	--------------------------------------------------------
norm_res
	ld b,a			; B(MSB),C,D,E(LSB): the result's mantissa

	sbc a,a			; if CY=1 -> A=-1 ($FF)
	jr nc,roundbit		; if CY=0 -> A= 0	- the correction -

	rr b			; CY -> bbbbbbbb -> CY
	rr c			; CY -> cccccccc -> CY
	rr d			; CY -> dddddddd -> CY
	rr e			; CY -> eeeeeeee -> CY
norm_end
	ret nc			;
;
;	--------------------------------------------------------
round32b	
	inc e			; set LS byte of the mantissa
	ret nz			; return if there is no overflow

	inc d			; set 3rd byte of the mantissa
	ret nz			; return if there is no overflow

	inc c			; set 2nd byte of the mantissa
	ret nz			; return if there is no overflow

	inc b			; set MS byte of the mantissa
	ret nz			; return if there is no overflow

	ld b,$80		; else set MSB and
	dec a			; adjust the correction
	ret			;
;
;	--------------------------------------------------------
roundbit
	exx			; ..	(alternate set)
	rl b			; restore the rounding bit (B'7)
	exx			; ..	(main set)
	jr norm_end		; and round if it is necessary
;
;	========================================================
add_nexp
	neg			; make it positive
add_pexp
	add a,h			; add the 2 exponents
	jp nc,set_Exp1		; store the result if not overflow
;
;	--------------------------------------------------------
;
;; REPORT-6 (L1880)
;
error_6
	rst 08h			; Error Report:
	.db $05			; Arithmetic overflow.
;
;	========================================================
;
; ---------------------------------
; THE improved 'DIVISION' OPERATION
; ---------------------------------
;
;; division (L1882)
;
;	========================================================
; in &
; out:	hl: points OP1 (the destination)
;	de: points OP2
;
division
	ld a,(de)		; check for division by zero
	and a			; if exp2=0,
	jr z,error_6		; then -> Arithmetic overflow
	
	ld c,a			; store exp2
	ld a,(hl)		; fetch exp1
	and a			; if it is zero,
	ret z			; then the result also is zero

	push de			; save the original
	push hl			; pointers

	ld b,a			; store exp1
	push bc			; save exp1,exp2

	call fetchOps		; fetch both mantissas into Z80 registers

	push af			; man1.S * man2.S
	push hl			; save pointer to the next calculator literal

	ld h,b			;
	ld l,c			; H'L' = upper 2 bytes of the dividend

	xor a			; clear MSB of the result
	ld b,a			; clear lower 2 bytes of the result
	ld c,a			; 

	exx			; switch back to main set
	ld h,b			;
	ld l,c			; H,L = lower 2 bytes of the dividend
	ld bc,$DF00		; B: a counter (-33), C: 2nd byte of the result
; ---
;
div_loop
	sbc hl,de		; subtract divisor part
	exx			; ..	(alternate set)
	sbc hl,de		;
	jr nc,shft_inv		; forward if there is no overflow

	exx			; ..	(main set)
	add hl,de		; else restore
	exx			; ..	(alternate set)
	adc hl,de		;
shft_inv
	ccf			; complement carry flag
shft_bin
	rl c			; multiply partial quotient by two
	rl b			; setting result bit from carry
	exx			; ..	(main set)
	rl c			;
	rla			;
	inc b			; increment the counter
	jr c,endofdiv		; exit, if the 33th bit is done

	add hl,hl		;
	exx			; ..	(alternate set)
	adc hl,hl		;
	exx			; ..	(main set)
	jr nc,div_loop		; 

	and a			; SUB-ONLY
	sbc hl,de		;
	exx			; ..	(alternate set)
	sbc hl,de		;

	scf			; set CY to shift '1' into
	jr shft_bin		; the partial quotient
endofdiv
	exx			; ..	(alternate set)
	pop hl			; pointer to the next calculator literal
	push bc			; the lower 2 bytes of the mantissa
	exx			; ..	(main set)
	pop de			; D,E = lower 2 bytes of the mantissa

	pop hl			; man1.S * man2.S
	ex (sp),hl		; exp1,exp2
	djnz divbit33		; skip if there were 33 subtractions

	inc l			; else set correction
divbit33
	call norm_res		; shift right and round (if it is necessary)

	add a,l			; fetch exp2 and set correction
	sub $80			; remove the offset
	jr c,add_nexp		; jump if it is negative

	jp sub_pexp		; else go to subtract from exp1
;
;	========================================================
;
	.db $76				; Newline
Line0End	

Line1	.db $00,$01			; Line 1
	.dw Line1End-Line1Text
Line1Text
	.db $E9,VarNam,$10,$C5,$0B	; DIM A..E( VAL "
	.db $1E,$1C,$1C,$1C,$0B,$11	; 2000")
	.db $76				; Newline
Line1End 

Line2	.db $00,$02
	.dw Line2End-Line2Text
Line2Text
	.db $F5,$0B,$27,$31,$34,$28,$30,$00	; PRINT "BLOCK_
	.db $26,$29,$29,$37,$2A,$38,$38,$0E	; ADDRESS:
	.db $00,$0B,$19,$D4,$C5			; _"; USR VAL
	.db $0B,$1D,$22,$21,$1D,$24,$0B		; "16518"
	.db $76					; Newline
Line2End 

Line3	.db $00,$03
	.dw Line3End-Line3Text
Line3Text
	.db $F5,$1A,$1A,$0B,$35,$37,$2A,$38,$38	; PRINT ,,"PRESS
	.db $00,$26,$00,$30,$2A,$3E,$0B		; _A_KEY"
	.db $76					; Newline
Line3End 

Line4	.db $00,$04
	.dw Line4End-Line4Text
Line4Text
	.db $FA,$41,$14,$0B,$0B,$DE,$EC		; IF INKEY$="" THEN GOTO
	.db $C4,$0B,$04,$0B			; CODE "char4"
	.db $76					; Newline
Line4End 

Line5	.db $00,$05
	.dw Line5End-Line5Text
Line5Text
	.db $F5,$1A,$1A,$0B,$1D,$1C,$1C,$1C,$00	; PRINT ,,"1000_
	.db $26,$29,$29,$2E,$39,$2E,$34,$33,$38	; ADDITIONS
	.db $00,$12,$00,$2B,$37,$26,$32,$2A,$38	; _>_FRAMES
	.db $0E,$0B				; :"
	.db $76					; Newline
Line5End 

Line6	.db $00,$06
	.dw Line6End-Line6Text
Line6Text
	.db $F5,$1A,$1A,$0B,$34,$31,$29,$00,$12	; PRINT ,,"OLD_>
	.db $00,$0B,$19,$D4,$C5			; _"; USR VAL
	.db $0B,$1D,$22,$21,$1D,$20,$0B		; "16514"
	.db $76					; Newline
Line6End 

Line7	.db $00,$07
	.dw Line7End-Line7Text
Line7Text
	.db $F5,$1A,$1A,$0B,$35,$37,$2A,$38,$38	; PRINT ,,"PRESS
	.db $00,$26,$00,$30,$2A,$3E,$0B		; _A_KEY"
	.db $76					; Newline
Line7End 

Line8	.db $00,$08
	.dw Line8End-Line8Text
Line8Text
	.db $FA,$41,$14,$0B,$0B,$DE,$EC		; IF INKEY$="" THEN GOTO
	.db $C4,$0B,$08,$0B			; CODE "char8"
	.db $76					; Newline
Line8End 

Line9	.db $00,$09
	.dw Line9End-Line9Text
Line9Text
	.db $F5,$1A,$1A,$0B,$33,$2A,$3C,$00,$12	; PRINT ,,"NEW_>
	.db $00,$0B,$19,$D4,$C5			; _"; USR VAL
	.db $0B,$1D,$22,$21,$1D,$22,$0B		; "16516"
	.db $76					; Newline
Line9End 

;	====================================================
Display
	.db $76	; Newline
	.db $76 ; Line 01
	.db $76 ; Line 02
	.db $76 ; Line 03
	.db $76 ; Line 04
	.db $76 ; Line 05
	.db $76 ; Line 06
	.db $76 ; Line 07
	.db $76 ; Line 08
	.db $76 ; Line 09
	.db $76 ; Line 10
	.db $76 ; Line 11
	.db $76 ; Line 12
	.db $76 ; Line 13
	.db $76 ; Line 14
	.db $76 ; Line 15
	.db $76 ; Line 16
	.db $76 ; Line 17
	.db $76 ; Line 18
	.db $76 ; Line 19
	.db $76 ; Line 20
	.db $76 ; Line 21
	.db $76 ; Line 22
	.db $76 ; Line 23
	.db $76 ; Line 24		

; Variables area (empty)
Variables:	
	.db $80
BasicEnd:				

